/* Copyright (C) 2000  Britton Leo Kerin, see copyright. */

/* This function causes the calling process to sleep for time seconds
   or samples samples (given sampling rate speed Hz).  */

#include <math.h>
#include <time.h>

void sleep_on_option(double time, double samples, int speed)
{
  if ( time != 0 || samples != 0 /* || date != NULL */ ) {
    struct timespec reqst, remst;

    /* if ( date_sleep > time && date_sleep > samples / speed ) */
      /* Unimplemented */
    /* else */ if ( time > samples / speed ) {
      reqst.tv_sec = (time_t) floor(time);
      reqst.tv_nsec = (long) rint((time - floor(time)) * 1000000);      
    } else {			/* time !> samples / speed */
      reqst.tv_sec = (time_t) floor(samples / speed);
      reqst.tv_nsec = (long) rint((samples / speed - floor(samples / speed))
                                  * 1000000);
    }    
    /* Do the actual sleeping. */     
    if ( nanosleep(&reqst, &remst) == -1 )
      ; /* Unimplemented, ultimately to be sleep continuation after interrupt.
         */
  }

  return;
}
